#SingleInstance Force
#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.

; NOTE: as of now, the underground script is different from the others. i plan to merge them later once i have a non-jank implementation of handling different types of games, or i go through the rest of the pointers and find a better one.

SplitPath,A_ScriptFullPath,,,,scriptName
cfile := A_ScriptDir . "\" . scriptName . ".ini"

;// basic config
IniRead,	gameExe,					%cfile%,	basic,			gameExe
IniRead,	keyShiftUp,					%cfile%,	basic,			keyShiftUp,		LShift
IniRead,	keyShiftDown,				%cfile%,	basic,			keyShiftDown,	LControl
IniRead,	joystickNumber,				%cfile%,	basic,			joystickNumber,	0
IniRead,	tickTime,					%cfile%,	basic,			tickTime,		33
IniRead,	pressTime,					%cfile%,	basic,			pressTime,		50
IniRead,	pressWait,					%cfile%,	basic,			pressWait,		50

;// gear buttons
IniRead,	joystickGearButtonsStr,		%cfile%,	buttonsGears

;// advanced
IniRead,	memoryGear,					%cfile%,	advanced,		memoryGear

versionMajor := 0
versionMinor := 2
versionDate := 2008
versionString := versionMajor . "." . versionMinor . "." . versionDate
title := "dumb-hshift " . versionString . " (" . scriptName . ")"

joystickGearButtons := {}
joystickGearButtonsWl := StrSplit(joystickGearButtonsStr,"`n")
Loop % joystickGearButtonsWl.MaxIndex()
{
	sep := StrSplit(joystickGearButtonsWl[A_Index],"=",,2)
	joystickGearButtons[sep[1]] := sep[2]
}

VarSetCapacity(joystickGearButtonsStr,0)
VarSetCapacity(joystickGearButtonsWl,0)

;// script start
IsWhole(Number){
	return !Mod(Number, Floor(number))
}

if (joystickNumber == 0) {
	TrayTip,%title%,auto-querying for joypad (press a button)...,,0x10
	timeWaited := 0
	joyFind:
	Loop
	{
		Loop 16  ; Query each joystick number to find out which ones exist.
		{
			joyInd := A_Index
			GetKeyState, JoyName, %joyInd%JoyName
			if JoyName <>
			{
				GetKeyState, joystickButtons, %joyInd%JoyButtons
				Loop, %joystickButtons%
				{
					joyBut := A_Index
					GetKeyState, joy%joyBut%, %joyInd%joy%joyBut%
					if (joy%joyBut% == "D") {
						joystickNumber := joyInd
						Break joyFind
					}
				}
			}
		}
		
		timeWaited := timeWaited + 100
		if (timeWaited >= 300000) {
			TrayTip,%title%,quitting due to inactivity.,,0x10
			Sleep, 5000
			ExitApp
		}
		
		if (timeWaited >= 30000 and IsWhole(timeWaited / 30000)) {
			TrayTip,%title%,reminder: auto-querying for joypad (press a button)...,,0x10
		}
		
		Sleep, 100
	}
	TrayTip,%title%,joypad chosen: %joystickNumber%,,0x10
}

SetKeyDelay,0,0,
GetKeyState, joystickButtons, %joystickNumber%JoyButtons
WinGet, pid, PID, ahk_exe %gameExe%
if not (pid) {
	TrayTip,%title%,waiting for %gameExe%...,,0x10
	timeWaited = 0
	Loop {
		WinGet, pid, PID, ahk_exe %gameExe%
		if (pid) {
			break
		}
		
		timeWaited := timeWaited + 100
		if (timeWaited >= 300000) {
			TrayTip,%title%,quitting due to inactivity.,,0x10
			Sleep, 5000
			ExitApp
		}
		
		if (timeWaited >= 30000 and IsWhole(timeWaited / 30000)) {
			TrayTip,%title%,reminder: waiting for %gameExe%...,,0x10
		}
		
		Sleep, 100
	}
}

TrayTip,%title%,now observing %gameExe% (pid: %pid%),,0x10
processBaseAddress := getProcessBaseAddress(pid)

Outer:
Loop {
	Process, Exist, %pid%
	if (ErrorLevel == 0) {
		TrayTip,%title%,%gameExe% closed`, quitting.,,0x10
		Sleep, 5000
		ExitApp
	}
	WinGet, aID,, A
	WinGet, aPID, PID, ahk_id %aID%
	if (aPID != pid) {
		Sleep, %tickTime%
		continue
	}
	
	gearS := Chr(ReadMemory(pid,processBaseAddress+memoryGear,"Char"))
	if (gearS = "N") {
		Sleep, %tickTime%
		continue ;// not handling neutral, as it disrupts the race start and because you can't shift into it instantly anyways
		gearS := "0"
	}
	
	if (gearS = "R") {
		Sleep, %tickTime%
		continue ;// underground - most wanted do not allow you to shift in/out of reverse manually
		gearS := "-1"
	}
	
	gear := Format("{:i}",gearS)
	if (gear = 0 and gearS != "0") { ;// invalid gear
		Sleep, %tickTime%
		continue
	}
	
	Jb:
	Loop, %joystickButtons%
	{
		GetKeyState, joy%A_Index%, %joystickNumber%joy%A_Index%
		if (joy%A_Index% != "D") {
			continue Jb
		}
		
		button := Format("{:d}",A_Index)
		if (joystickGearButtons[button]) {
			wantedGear := Format("{:d}",joystickGearButtons[button])
			key := "NONE"
			if (gear < wantedGear) {
				key := keyShiftUp
			}
			
			if (gear > wantedGear) {
				key := keyShiftDown
			}
			
			if (key != "NONE") {
				; ControlSend,ahk_parent,{%key% down},ahk_id %aID%
				Send,{%key% down}
				Sleep, %pressTime%
				Send,{%key% up}
				Sleep, %pressWait%
				continue Outer
			}
		}
	}
	
	Sleep, %tickTime%
}
return

getProcessBaseAddress(pid)
{
    SetFormat, IntegerFast, hex
    WinGet, hWnd, ID, ahk_pid %pid%
    BaseAddress := DllCall(A_PtrSize = 4
        ? "GetWindowLong"
        : "GetWindowLongPtr", "Uint", hWnd, "Uint", -6)
    return BaseAddress
}

ReadMemory(pid, address, type := "Int")
{
	static aTypeSize := {   "UChar":    1,  "Char":     1
                        ,   "UShort":   2,  "Short":    2
                        ,   "UInt":     4,  "Int":      4
                        ,   "UFloat":   4,  "Float":    4 
                        ,   "Int64":    8,  "Double":   8} 

	if !aTypeSize.hasKey(type)
		return "", ErrorLevel := -2
	if !hProcess := DllCall("OpenProcess", "UInt", 24, "Int", False, "UInt", pid, "Ptr") 
		return
	success := DllCall("ReadProcessMemory", "Ptr", hProcess, "Ptr", address, type "*", result, "Ptr", aTypeSize[type], "Ptr",0)
	DllCall("CloseHandle", "Ptr", hProcess)
	return success ? result : ""
}

